<?php 
class Picksquares
{ 
    private static $payment;
    private static $pools;
    private static $fanvictor;
    public function __construct() 
    {
        self::$payment = new Payment();
        self::$pools = new Pools();
        self::$fanvictor = new Fanvictor();
    }
    
	public static function process() 
	{   
        if(isset($_POST) && isset($_POST["pickSquares"]))
        {
           
            add_action( 'wp_enqueue_scripts', array('Picksquares', 'theme_name_scripts') );
            add_filter('the_content', array('Picksquares', 'submitPick'));
        }
        else 
        {
            add_action( 'wp_enqueue_scripts', array('Picksquares', 'theme_name_scripts') );
            add_filter('the_content', array('Picksquares', 'addContent'));
        }
	} 
    
    public static function theme_name_scripts()
    {
        wp_enqueue_script('picksquares.js', FANVICTOR__PLUGIN_URL_JS.'picksquares.js');
        wp_enqueue_style('style.css', FANVICTOR__PLUGIN_URL_CSS.'style.css');
    }

    public static function addContent()
    {
        if(!in_the_loop())
        {
            return;
        }

        $leagueID = pageSegment(3);
        $entry_number = isset($_GET['num']) ? $_GET['num'] : 0;
        $data = self::$fanvictor->getEnterNormalGameData($leagueID, $entry_number);
        switch($data)
        {
            case 2:
                redirect(FANVICTOR_URL_CREATE_CONTEST, __('Contest does not exist', 'fantasy-sports'), true);
                break;
            case 3:
                redirect(FANVICTOR_URL_RANKINGS.$leagueId, null, true);
                break;
            case 4:
                redirect(FANVICTOR_URL_CREATE_CONTEST, __('Sorry! This contest was full', 'fantasy-sports'), true);
                break;
            case 5:
                redirect(FANVICTOR_URL_GAME.$leagueID.'/?num='.$entry_number, null, true);
                break;
            case 6:
                redirect(FANVICTOR_URL_CREATE_CONTEST, __('You can not edit started game', 'fantasy-sports'), true);
                break;
        }
        if(!self::$payment->isUserEnoughMoneyToJoin($data['league']['entry_fee'], $leagueID))
        {
            redirect(FANVICTOR_URL_ADD_FUNDS, __('You do not have enough funds to enter. Please add funds', 'fantasy-sports'));
        }
        else 
        {
            $aLeague = $data['league'];
            $aPool = $data['pool'];
            $otherLeagues = $data['otherLeagues'];
            $aFights = $data['fights'];
            $aMethods = $data['methods'];
            $aMinutes = $data['minutes'];
            $aRounds = $data['rounds'];
            $aPickSquare = $data['picksquares'];
            $picksquare = '';
            $userSquares = '';
            $payoutPickSquare = json_decode($aLeague['picksquares_payouts'],true);
            if(!empty($aPickSquare)){
                $picksquare = $aPickSquare['pick_squares'];
                $userSquares = $aPickSquare['user_squares'];
            }
            if(empty($userSquares)){
                $arr1 = range(0, 9);
                $arr2 = range(0, 9);
                shuffle($arr1);
                shuffle($arr2);
                $userSquares[] = $arr1;
                $userSquares[] = $arr2;
                $userSquares = json_encode($userSquares);
            }
            $creator = get_user_by("id", $aLeague['creator_userID']);
            // payout picksquare
            include FANVICTOR__PLUGIN_DIR_VIEW.'picksquares.php';
        }
    }
    
    public static function submitPick()
    {
        
        $leagueID = $_POST['leagueID'];
        $entry_number = $_POST['entry_number'];
        //league
        $league = self::$fanvictor->getLeagueDetail($leagueID);
        $league = $league[0];
        
        //pool
        self::$pools->selectField(array('status'));
        $aPool = self::$pools->getPools($league['poolID'], null, false, true);
        
        if(strtolower($league['gameType']) == 'playerdraft')
        {
            redirect(FANVICTOR_URL_GAME.$leagueID.'/?num='.$entry_number, null, true);
        }
        else if(!self::$fanvictor->isNormalLeagueExist($leagueID))
        {
            redirect(FANVICTOR_URL_CREATE_CONTEST, __('League not found', 'fantasy-sports'), true);
        }
        else if($aPool['status'] != 'NEW')//check league completed
        {
            redirect(FANVICTOR_URL_CREATE_CONTEST, __('This contest had completed', 'fantasy-sports'), true);
        }
        else if(!self::$payment->isUserEnoughMoneyToJoin($league['entry_fee'], $leagueID))
        {
            redirect(FANVICTOR_URL_ADD_FUNDS, __('You do not have enough funds to enter. Please add funds', 'fantasy-sports'));
        }
        else 
        {
           
            $elem_to_show = 'error_message';
            $showInvite = false;
            $errorMessage = '';
            $leagueID = 0;
            $poolID = 0;
            $leagueheader = '';
            $userID = $_COOKIE['fanvictor_user_id'];
            $elem_to_show = 'league_history';
            $isLive = $league['is_live'];

            $error = false;
            $_POST['get_summary'] = 'NO';
            $allowMinutes = false;
            $canPlayPayed = false;		// whether user can play payed leagues
            $aFriends = self::$fanvictor->getAllPlayerInfo();
            $iTotalFriends = count($aFriends);
            sort($aFriends, SORT_ASC);
            usort($aFriends, function($a, $b){
                $a = strtolower($a['full_name'] ? $a['full_name'] : $a['user_name']);
                $b = strtolower($b['full_name'] ? $b['full_name'] : $b['user_name']);
                return strcmp($a, $b);
            });

            $string = "";
            foreach ( $aFriends as $buddy )
            {
                # <input type="checkbox" name="vehicle" value="Bike" /> I have a bike<br />
                $full_name = $buddy["full_name"] ? $buddy["full_name"] : $buddy["user_name"];
                $string .= '<label><input type="checkbox" checked name="val[friend_ids][]" value="'.$buddy["ID"].'"> '.htmlspecialchars($full_name)."</label><br>";
            }

            $myString = $string;

            if ( isset($_REQUEST['poolID']) && $_REQUEST['poolID'] )	// modify or update
            {
                //league
                $jsonObject = self::$fanvictor->postUserPicks($_POST);
               
                if ( $jsonObject != null )
                {
                    if ( isset($jsonObject['success']) && $jsonObject['success'] )
                    {
                        if($jsonObject['entry_number'] > 0)
                        {
                            $makeBet = self::$payment->isMakeBetForLeague($league['leagueID'], $jsonObject['entry_number']);
                            if($makeBet == false)
                            {
                                //decrease user money
                                self::$payment->updateUserBalance($league['entry_fee'], true, $league['leagueID']);

                                //add to history
                                $aUser = self::$payment->getUserData();
                                self::$payment->addFundhistory($league['entry_fee'], $league['leagueID'], $aUser['balance'], 'MAKE_BET', 'DEDUCT', null, null, null, null, null, $jsonObject['entry_number']);
                            }
                        }

                        // get ranking table for pool
                        if ( (int)$jsonObject['leagueID'] )
                        {
                            if ( isset($jsonObject['no_userpicks']) && $jsonObject['no_userpicks'] )
                                $showInvite = 'true';

                            $leagueID = $jsonObject['leagueID'];
                            $poolID = $jsonObject['poolID'];
                            $leagueheader = $jsonObject['leagueheader'];
                            $allowMinutes = $jsonObject['minutes'];
                        }
                        else
                        {
                            $errorMessage = __('No league ID is set.', 'fantasy-sports');
                            $error = true;
                        }
                    }
                    else
                    {
                        if ( isset($jsonObject['reason']) )
                        {
                            if ( 'pool_expired' == $jsonObject['reason'] )
                            {
                                $errorMessage = __('The pool has expired. Your picks have NOT been submitted.', 'fantasy-sports');
                            }
                            elseif ( 'pool_full' == $jsonObject['reason'] )
                            {
                                $errorMessage = __('The pool has maximum amount of users. Your picks have NOT been submitted.', 'fantasy-sports');
                            }
                            elseif ( 'not_enough_funds' == $jsonObject['reason'] )
                            {
                                $errorMessage = __('You do NOT have enough funds to enter. Please ADD FUNDS.', 'fantasy-sports');
                            }
                            elseif ( 'cannot_play_payed' == $jsonObject['reason'] )
                            {
                                $errorMessage = __("Sorry, we cannot process your request. You can't play payed leagues.", 'fantasy-sports');

                            }
                            elseif ( 'same_league_has_been_already_created' == $jsonObject['reason'] )
                            {
                                $errorMessage = __('The league is not created because you have already created the same league.', 'fantasy-sports');
                            }else if('empty_pick_squares' == $jsonObject['reason']){
                                $errorMessage = __('Please select at least one square', 'fantasy-sports');
                            }
                        }
                        elseif ( isset($jsonObject['msg']) )
                        {
                            $errorMessage = $jsonObject['msg']."<br>Your picks have NOT been submitted";
                        }
                    }
                }
                else
                {
                    $errorMessage = __('Error occured. Your picks have NOT been submitted.', 'fantasy-sports');
                }
            }
            $_SESSION['userPicksInfo'] = array($leagueID, $_COOKIE['fanvictor_user_id'], 1);
            $_SESSION['showInviteFriends'.$leagueID] = true;
            redirect(FANVICTOR_URL_RANKINGS.$leagueID.'/?num='.$jsonObject['entry_number'], null, true);
            

        }
    }
} 
?>