<?php
/**
 * Plugin Name: Fan Victor
 * Plugin URI: http://plugins.svn.wordpress.org/fantasy-sports/ 
 * Description: Create a fantasy sports website in minutes. Give your members the chance to compete in daily contests by predicting the outcomes of sporting events.  To get started: 1) Click the "Activate" link to the left of this description, 2) Sign up for a Fan Victor API key, and 3) Go to your FanVictor.com members page, and save your API key.
 * Version: 2.1.42
 * Author: Mega Website Services
 * Author URI: http://fanvictor.com
 * License: GPL2
 */

/*  Copyright 2016  Mega Website Services  (email : support@fanvictor.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as 
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
ob_start();

$upload_dir = wp_upload_dir();
define('FANVICTOR_VERSION', '2.1.42');
define('FANVICTOR__PLUGIN_URL', plugin_dir_url(__FILE__));
define('FANVICTOR__PLUGIN_DIR', plugin_dir_path(__FILE__));
define('FANVICTOR__PLUGIN_DIR_MODEL', FANVICTOR__PLUGIN_DIR.'model/');
define('FANVICTOR__PLUGIN_DIR_VIEW', FANVICTOR__PLUGIN_DIR.'views/');
define('FANVICTOR__PLUGIN_DIR_CONTROLLER', FANVICTOR__PLUGIN_DIR.'controller/');
define('FANVICTOR__PLUGIN_URL_IMAGE', FANVICTOR__PLUGIN_URL.'_inc/image/');
define('FANVICTOR__PLUGIN_URL_CSS', FANVICTOR__PLUGIN_URL.'_inc/css/');
define('FANVICTOR__PLUGIN_URL_JS', FANVICTOR__PLUGIN_URL.'_inc/jscript/');
define('FANVICTOR__PLUGIN_URL_AJAX', FANVICTOR__PLUGIN_URL.'fanvictor.php');
define('FANVICTOR_IMAGE_URL', $upload_dir['baseurl'].'/');
define('FANVICTOR_IMAGE_DIR', $upload_dir['basedir'].'/');
define('FANVICTOR_EMAIL_SUPPORT', 'support@fanvictor.com');
define('FANVICTOR_PAYPAL_TYPE_NORMAL', 0);
define('FANVICTOR_PAYPAL_TYPE_PRO', 1);
define('FANVICTOR_PAYOUT_GATEWAY_PAYPAL', 0);
define('FANVICTOR_PAYOUT_GATEWAY_PRIORITY', 1);



$permalink_structure = get_option('permalink_structure');
if($permalink_structure == '')
{
	$mypage = get_page_by_title('Create Contest');
	define('FANVICTOR_URL_CREATE_CONTEST', site_url().'/?page_id='.$mypage->ID);

	$mypage = get_page_by_title('Submit Picks');
	define('FANVICTOR_URL_SUBMIT_PICKS', site_url().'/?page_id='.$mypage->ID);

	$mypage = get_page_by_title('Add Funds');
	define('FANVICTOR_URL_ADD_FUNDS', site_url().'/?page_id='.$mypage->ID);

	$mypage = get_page_by_title('Notify Add Funds');
	define('FANVICTOR_URL_NOTIFY_ADD_FUNDS', site_url().'/?page_id='.$mypage->ID);

	$mypage = get_page_by_title('Success Add Funds');
	define('FANVICTOR_URL_SUCCESS_ADD_FUNDS', site_url().'/?page_id='.$mypage->ID);

	$mypage = get_page_by_title('Rankings');
	define('FANVICTOR_URL_RANKINGS', site_url().'/?page_id='.$mypage->ID);

	$mypage = get_page_by_title('Withdrawal History');
	define('FANVICTOR_URL_REQUEST_HISTORY', site_url().'/?page_id='.$mypage->ID);

	$mypage = get_page_by_title('Transactions');
	define('FANVICTOR_URL_TRANSACTIONS', site_url().'/?page_id='.$mypage->ID);

	$mypage = get_page_by_title('Success Withdrawls');
	define('FANVICTOR_URL_SUCCESS_WITHDRAWLS', site_url().'/?page_id='.$mypage->ID);

	$mypage = get_page_by_title('Notify Withdrawls');
	define('FANVICTOR_URL_NOTIFY_WITHDRAWLS', site_url().'/?page_id='.$mypage->ID);
    
    $mypage = get_page_by_title('Game');
	define('FANVICTOR_URL_GAME', site_url().'/?page_id='.$mypage->ID);
    
    $mypage = get_page_by_title('Entry');
	define('FANVICTOR_URL_ENTRY', site_url().'/?page_id='.$mypage->ID);
    
    $mypage = get_page_by_title('Contest');
	define('FANVICTOR_URL_CONTEST', site_url().'/?page_id='.$mypage->ID);

    $mypage = get_page_by_title('Pick Square');
    define('FANVICTOR_URL_PICK_SQUARES', site_url().'/?page_id='.$mypage->ID);
}
else 
{
	define('FANVICTOR_URL_CREATE_CONTEST', site_url().'/fantasy/create-contest/');
	define('FANVICTOR_URL_SUBMIT_PICKS', site_url().'/fantasy/submit-picks/');
    define('FANVICTOR_URL_GAME', site_url().'/fantasy/game/');
    define('FANVICTOR_URL_ENTRY', site_url().'/fantasy/entry/');
    define('FANVICTOR_URL_CONTEST', site_url().'/fantasy/contest/');
    define('FANVICTOR_URL_LOBBY', site_url().'/fantasy/lobby/');
	define('FANVICTOR_URL_ADD_FUNDS', site_url().'/fantasy/add-funds/');
	define('FANVICTOR_URL_NOTIFY_ADD_FUNDS', site_url().'/fantasy/notify-add-funds/');
	define('FANVICTOR_URL_SUCCESS_ADD_FUNDS', site_url().'/fantasy/success-add-funds/');
	define('FANVICTOR_URL_RANKINGS', site_url().'/fantasy/rankings/');
	define('FANVICTOR_URL_REQUEST_HISTORY', site_url().'/fantasy/withdrawal-history/');
	define('FANVICTOR_URL_TRANSACTIONS', site_url().'/fantasy/transactions/');
	define('FANVICTOR_URL_SUCCESS_WITHDRAWLS', site_url().'/fantasy/success-withdrawls/');
	define('FANVICTOR_URL_NOTIFY_WITHDRAWLS', site_url().'/fantasy/notify-withdrawls/');
    define('FANVICTOR_URL_PICK_SQUARES', site_url().'/fantasy/pick-squares/');


	
}

function caption_shortcode( $atts, $content = null ) {
	return Lobby::show();
}
add_shortcode( 'fanvictor_lobby', 'caption_shortcode' );

//add footer
function fv_footer(){
	echo '<div style="background-color:#FFFFFF;color:#333333;padding:20px;">';
    echo '<div style="text-align:center;font-size:12px;">';
	echo __('This site is a Game of Skill and is 100% LEGAL in the United States. This site operates in full compliance with the Unlawful Internet Gambling Enforcement Act of 2006.', 'fantasy-sports');
    echo '</div>';
    echo '<div style="text-align:center;margin-top:5px;font-size:12px;">';
    echo sprintf(__('Due to state and provincial laws residents of Arizona, Iowa, Louisiana, Montana, Vermont, New York and Quebec may only play in free competitions. All other trademarks and logos belong to their respective owners. %s Fantasy Sports', 'fantasy-sports'), '<a style="color:#000000" href="http://fanvictor.com" target="_blank">FanVictor.com</a>');
    echo '</div>';
	echo '</div>';
}
add_action('wp_footer', 'fv_footer');

//init
require_once(FANVICTOR__PLUGIN_DIR.'class.init.php');
register_activation_hook(__FILE__, array('FanvictorInit', 'active'));
register_deactivation_hook(__FILE__, array('FanvictorInit', 'deactivate'));
register_uninstall_hook(__FILE__, array('FanvictorInit', 'uninstall'));
add_action( 'plugins_loaded', array('FanvictorInit', 'upgrade'));
require_once(plugin_dir_path(__FILE__)."/languages/js-pt_PT.php");

add_action('init', 'session_start');
function fv_init(){
	load_plugin_textdomain('fantasy-sports', false, dirname(plugin_basename(__FILE__))."/languages/");
}

add_action('plugins_loaded', 'fv_init');
$fanvictor_allow_change_background = fanvictorCheckAllowChangebackground();
function fanvictor_require_class(){
    require_once(FANVICTOR__PLUGIN_DIR_MODEL . 'admin/pools.php');
    require_once(FANVICTOR__PLUGIN_DIR_MODEL . 'admin/fighters.php');
    require_once(FANVICTOR__PLUGIN_DIR_MODEL . 'admin/teams.php');
    require_once(FANVICTOR__PLUGIN_DIR_MODEL . 'admin/organizations.php');
    require_once(FANVICTOR__PLUGIN_DIR_MODEL . 'admin/user.php');
    require_once(FANVICTOR__PLUGIN_DIR_MODEL . 'admin/statistic.php');
    require_once(FANVICTOR__PLUGIN_DIR_MODEL . 'payment.php');
    require_once(FANVICTOR__PLUGIN_DIR_MODEL . 'fanvictor.php');
    require_once(FANVICTOR__PLUGIN_DIR_MODEL . 'mypaypal.php');
    require_once(FANVICTOR__PLUGIN_DIR_MODEL . 'admin/sports.php');
    require_once(FANVICTOR__PLUGIN_DIR_MODEL . 'admin/playerposition.php');
    require_once(FANVICTOR__PLUGIN_DIR_MODEL . 'admin/scoringcategory.php');
    require_once(FANVICTOR__PLUGIN_DIR_MODEL . 'admin/players.php');
    require_once(FANVICTOR__PLUGIN_DIR_MODEL . 'admin/leagues.php');
    require_once(FANVICTOR__PLUGIN_DIR_MODEL . 'admin/playernews.php');
    require_once(FANVICTOR__PLUGIN_DIR_MODEL . 'CouponModel.php');
}

// add field when sign up
if($fanvictor_allow_change_background){
    add_action( 'register_form', 'fanvictor_add_registration_fields' );
    add_action( 'user_register', 'fanvictor_user_register' );
}


function fanvictorShowTeamsField(){
    $mSports= new Sports();
    $aSports = $mSports->getSports();
    $aSportTeams = array();
    foreach($aSports as $aSport){
        if($aSport['is_team'] != 1 || $aSport['is_active'] != 1 || $aSport['siteID'] != 0){
            continue;
        }
        $aSport = $aSport['child'];
        foreach($aSport as $sport){
            if($sport['is_team'] != 1 || $sport['is_active'] != 1 || $sport['siteID'] != 0){
                continue;
            }
            $aSportTeams[$sport["id"]] = $sport["name"];
        }
    }

    if(empty($aSportTeams)){
        return;
    }
    $fanvictor = new Fanvictor();
    $listSports = $fanvictor->getTeamsBySports(array_keys($aSportTeams));
    return array($listSports,$aSportTeams);

}

function fanvictor_add_registration_fields() {
    require_once(FANVICTOR__PLUGIN_DIR_MODEL.'admin/sports.php');
    require_once(FANVICTOR__PLUGIN_DIR_MODEL.'fanvictor.php');
    list($listSports, $aSportTeams)= fanvictorShowTeamsField();
    if(!empty($listSports)){
        echo '<p><label for="team_info">'.__('Teams','fantasy-sports').'</label>';
        echo '<select  name="team_info" id="team-info" class="input">';
        foreach($listSports as $sport_id=>$sports){
            echo '<optgroup  label="'.$aSportTeams[$sport_id].'">';
                foreach($sports as $item){
                    echo '<option value="'.$sport_id.'_'.$item['teamID'].'">'.$item['name'].'</option>';
                }
            echo '</optgroup>';
        }
        echo '</select></p>';
    }
    
}
 function fanvictor_user_register( $user_id ) {
        if ( isset($_POST['team_info']) && ! empty( $_POST['team_info'] ) ) {
           global $wpdb;
           $tb_user_teams = $wpdb->prefix.'user_teams';
           $user = $wpdb->get_row("SELECT * FROM $tb_user_teams WHERE user_id=$user_id",ARRAY_A);
           $team_info = $_POST['team_info'];
           $info = explode('_',$team_info);
           $org_id = $info[0];
           $teamID = $info[1];
           if(!empty($user)){ // update
               $id = $user['id'];
               $wpdb->update(
                       $tb_user_teams,
                       array('team_id'=>$teamID,'org_id'=>$org_id),
                       array('id'=>$id),
                       array('%d','%d'),
                       array('%d')
                       );
           }else{ // insert
               $wpdb->insert(
                       $tb_user_teams,
                       array('user_id'=>$user_id,'team_id'=>$teamID,'org_id'=>$org_id),
                       array('%d','%d','%d')
                       );
           }
        }
}

// for user profile
if($fanvictor_allow_change_background){
    add_action( 'show_user_profile', 'fanvictor_add_custom_profile_fields' );
    add_action( 'profile_update', 'fanvictor_save_custom_profile_fields' ); 
}

function fanvictor_add_custom_profile_fields($user) {
    fanvictor_require_class();
    global $wpdb;
    $tb_user_teams = $wpdb->prefix . 'user_teams';
    $user_id = $user->data->ID;
    $team = $wpdb->get_row("SELECT * FROM $tb_user_teams WHERE user_id=$user_id", ARRAY_A);

    $team_id = 0;
    $id = 0;
    if (!empty($team)) {
        $team_id = $team['team_id'];
    }
    list($aSports,$aSportsName) = fanvictorShowTeamsField();
    if (empty($aSports)) {
        return;
    }
    ?>
   
    <table class="form-table">
        <tr>
            <th><label for="teams-info"><?php echo __('Teams', 'fantasy-sports') ?></label></th>
            <td>
                <select id="teams-info" name="teams_info">
                    <?php foreach ($aSports as $sport_id=>$aSport):  ?>
                        <optgroup label="<?php echo $aSportsName[$sport_id] ?>">
                            <?php foreach($aSport as $sport): ?>
                            <option <?php echo ($sport['teamID'] == $team_id)?'selected':'' ?> value="<?php echo $sport_id.'_'.$sport['teamID'] ?>"><?php echo $sport['name']; ?></option>
                            <?php endforeach; ?>
                        </optgroup>
                    <?php endforeach; ?>
                </select>
            </td>
        </tr>
    </table>
    <?php
}

function fanvictor_save_custom_profile_fields($user_id) {
    if (isset($_POST['teams_info']) && !empty($_POST['teams_info'])) {
        global $wpdb;
        $team_info = $_POST['teams_info'];
        $info = explode('_', $team_info);
        $tb_user_teams = $wpdb->prefix . 'user_teams';
        $teams = $wpdb->get_row("SELECT * FROM $tb_user_teams WHERE user_id=$user_id",ARRAY_A);
        $teamID = $info[1];
        $org_id = $info[0];
        if (!empty($teams)) { // update
            $id = $teams['id'];
            $wpdb->update(
                    $tb_user_teams, array('team_id' => $teamID, 'org_id' => $org_id), array('id' => $id), array('%d', '%d'), array('%d')
            );
        } else {// insert
            $wpdb->insert(
                    $tb_user_teams, array('user_id' => $user_id, 'team_id' => $teamID, 'org_id' => $org_id), array('%d', '%d', '%d')
            );
        }
    }
}

// change background image
//if($fanvictor_allow_change_background){
//    add_action( 'plugins_loaded', 'fanvictor_change_user_background');
//}

//function fanvictor_change_user_background() {
//    $is_allow = fanvictorCheckAllowChangebackground();
//    if(!$is_allow){
//        return false;
//    }
//    
//    global $wpdb;
//    $tbl_user_teams = $wpdb->prefix . 'user_teams';
//    $user_id = get_current_user_id();
//    $team = $wpdb->get_row("SELECT * FROM $tbl_user_teams WHERE user_id=$user_id", ARRAY_A);
//    if (!empty($team)) {
//        $f_img_path = FANVICTOR__PLUGIN_DIR . 'assets/teams/' . $team['team_id'];
//        $file_info = glob($f_img_path.'.*');
//        if (!empty($file_info) && file_exists($file_info[0])) {
//            $option_name = get_option('theme_mods_FV-Professional');
//            if(isset($option_name['background_image']) && !empty($option_name['background_image'])){
////                $new_option = unserialize('a:1:{i:0;b:0;}');
////                update_option('theme_mods_FV-Professional', $new_option);
//               
//            }
//            $abs_path_img = $file_info[0];
//            $aPath = explode('/',$abs_path_img);
//            $file_name = $aPath[count($aPath)-1];
//
//            $args = array(
//              'default-color'=>'000000',
//               'default-image' => FANVICTOR__PLUGIN_URL."assets/teams/$file_name"
//            );
//            add_theme_support('custom-background', $args);
//        }
//    }
//}
function fanvictorCheckAllowChangebackground(){
    fanvictor_require_class();
    $fv = new Fanvictor();
    $is_allow = $fv->checkAllowChangeBackground();
    return $is_allow['is_allow'];
    
}


add_filter('body_class','fv_hardcore_background');
function fv_hardcore_background($classes){
    $classes[] = 'fv_background_class';
    return $classes;
}
if($fanvictor_allow_change_background){
  add_action('wp_enqueue_scripts', 'fv_change_background_by_user');  
}
function fv_change_background_by_user(){
   $is_allow = fanvictorCheckAllowChangebackground();
    if(!$is_allow){
        return false;
    }
    
    global $wpdb;
    $tbl_user_teams = $wpdb->prefix . 'user_teams';
    $user_id = get_current_user_id();
    $team = $wpdb->get_row("SELECT * FROM $tbl_user_teams WHERE user_id=$user_id", ARRAY_A);
    if (!empty($team)) {
        $f_img_path = FANVICTOR__PLUGIN_DIR . 'assets/teams/' . $team['team_id'];
        $file_info = glob($f_img_path.'.*');
        if (!empty($file_info) && file_exists($file_info[0])) {
            $abs_path_img = $file_info[0];
            $aPath = explode('/',$abs_path_img);
            $file_name = $aPath[count($aPath)-1];
            $url_background = FANVICTOR__PLUGIN_URL."assets/teams/$file_name";
            echo "<style>body.fv_background_class{background-image:url('".$url_background."') !important;}</style>";
            
        }
    }
}

?>